Botan: Botan::SEED Class Reference

Botan 1.10.16

Classes | Public Types | Public Member Functions | List of all members
Botan::SEED Class Reference

`#include <seed.h>`

Inheritance diagram for Botan::SEED:

## Public Types
enum |

## Public Member Functions
size_t | block_size () const
void | clear ()
BlockCipher * | clone () const
void | decrypt (const byte in[], byte out[]) const
void | decrypt (byte block[]) const
void | decrypt_n (const byte in[], byte out[], size_t blocks) const
void | encrypt (const byte in[], byte out[]) const
void | encrypt (byte block[]) const
void | encrypt_n (const byte in[], byte out[], size_t blocks) const
Key_Length_Specification | key_spec () const
size_t | maximum_keylength () const
size_t | minimum_keylength () const
std::string | name () const
size_t | parallel_bytes () const
virtual size_t | parallelism () const
| SEED ()
void | set_key (const SymmetricKey &key)
void | set_key (const byte key[], size_t length)
bool | valid_keylength (size_t length) const

## Detailed Description

SEED, a Korean block cipher

Definition at line 18 of file seed.h.

## Member Enumeration Documentation

## ◆ anonymous enum

anonymous enum
| inherited

Definition at line 107 of file block_cipher.h.

107 { BLOCK_SIZE = BS };
Botan::Block_Cipher_Fixed_Params< 16, 16 >::BLOCK_SIZE
Definition: block_cipher.h:107

## Constructor & Destructor Documentation

## ◆ SEED()

Botan::SEED::SEED | ( |  | ) |
| inline

Definition at line 28 of file seed.h.

28 : K(32) {}

## Member Function Documentation

## ◆ block_size()

size_t Botan::Block_Cipher_Fixed_Params< BS, KMIN, 0 , 1 >::block_size | ( |  | ) | const
| inlinevirtualinherited

Returns
  block size of this algorithm

Implements Botan::BlockCipher.

Definition at line 108 of file block_cipher.h.

108 { return BS; }

## ◆ clear()

void Botan::SEED::clear | ( |  | ) |
| inlinevirtual

Zeroize internal state

Implements Botan::Algorithm.

Definition at line 24 of file seed.h.

References Botan::zeroise().

24 { zeroise(K); }
Botan::zeroise
void zeroise(MemoryRegion< T > &vec)
Definition: secmem.h:415

## ◆ clone()

BlockCipher* Botan::SEED::clone | ( |  | ) | const
| inlinevirtual

Get a new object representing the same algorithm as *this

Implements Botan::BlockCipher.

Definition at line 26 of file seed.h.

26 { return new SEED; }
Botan::SEED::SEED
SEED()
Definition: seed.h:28

## ◆ decrypt() [1/2]

void Botan::BlockCipher::decrypt | ( | const byte | in[],
|  | byte | out[]
| ) |  | const
| inlineinherited

Decrypt a block.

Parameters

  in | The ciphertext block to be decypted as a byte array. Must be of length block_size().
  out | The byte array designated to hold the decrypted block. Must be of length block_size().

Definition at line 57 of file block_cipher.h.

Referenced by Botan::DESX::decrypt_n(), Botan::ECB_Decryption::name(), Botan::CTS_Decryption::set_iv(), and Botan::CBC_Decryption::set_iv().

58 { decrypt_n(in, out, 1); }
Botan::BlockCipher::decrypt_n
virtual void decrypt_n(const byte in[], byte out[], size_t blocks) const =0

## ◆ decrypt() [2/2]

void Botan::BlockCipher::decrypt | ( | byte | block[] | ) | const
| inlineinherited

Decrypt a block.

Parameters

  block | the ciphertext block to be decrypted Must be of length block_size(). Will hold the result when the function has finished.

Definition at line 74 of file block_cipher.h.

74 { decrypt_n(block, block, 1); }
Botan::BlockCipher::decrypt_n
virtual void decrypt_n(const byte in[], byte out[], size_t blocks) const =0

## ◆ decrypt_n()

void Botan::SEED::decrypt_n | ( | const byte | in[],
|  | byte | out[],
|  | size_t | blocks
| ) |  | const
| virtual

Decrypt one or more blocks

Parameters

  in | the input buffer (multiple of block_size())
  out | the output buffer (same size as in)
  blocks | the number of blocks to process

Implements Botan::BlockCipher.

Definition at line 65 of file seed.cpp.

References Botan::Block_Cipher_Fixed_Params< 16, 16 >::BLOCK_SIZE, Botan::get_byte(), Botan::load_be< u32bit >(), and Botan::store_be().

66 {
67 for(size_t i = 0; i != blocks; ++i)
68 {
69 u32bit B0 = load_be<u32bit>(in, 0);
70 u32bit B1 = load_be<u32bit>(in, 1);
71 u32bit B2 = load_be<u32bit>(in, 2);
72 u32bit B3 = load_be<u32bit>(in, 3);
73
74 G_FUNC G;
75
76 for(size_t j = 0; j != 16; j += 2)
77 {
78 u32bit T0, T1;
79
80 T0 = B2 ^ K[30-2*j];
81 T1 = G(B2 ^ B3 ^ K[31-2*j]);
82 T0 = G(T1 + T0);
83 T1 = G(T1 + T0);
84 B1 ^= T1;
85 B0 ^= T0 + T1;
86
87 T0 = B0 ^ K[28-2*j];
88 T1 = G(B0 ^ B1 ^ K[29-2*j]);
89 T0 = G(T1 + T0);
90 T1 = G(T1 + T0);
91 B3 ^= T1;
92 B2 ^= T0 + T1;
93 }
94
95 store_be(out, B2, B3, B0, B1);
96
97 in += BLOCK_SIZE;
98 out += BLOCK_SIZE;
99 }
100 }
Botan::Block_Cipher_Fixed_Params< 16, 16 >::BLOCK_SIZE
Definition: block_cipher.h:107
Botan::load_be< u32bit >
u32bit load_be< u32bit >(const byte in[], size_t off)
Definition: loadstor.h:166
Botan::store_be
void store_be(u16bit in, byte out[2])
Definition: loadstor.h:412
Botan::u32bit
unsigned int u32bit
Definition: types.h:32

## ◆ encrypt() [1/2]

void Botan::BlockCipher::encrypt | ( | const byte | in[],
|  | byte | out[]
| ) |  | const
| inlineinherited

Encrypt a block.

Parameters

  in | The plaintext block to be encrypted as a byte array. Must be of length block_size().
  out | The byte array designated to hold the encrypted block. Must be of length block_size().

Definition at line 47 of file block_cipher.h.

Referenced by Botan::aont_unpackage(), Botan::OFB::cipher(), Botan::DESX::encrypt_n(), Botan::CMAC::poly_double(), Botan::ANSI_X931_RNG::randomize(), Botan::Randpool::randomize(), Botan::CTS_Encryption::set_iv(), Botan::CFB_Encryption::set_iv(), Botan::OFB::set_iv(), Botan::XTS_Encryption::set_iv(), Botan::CBC_Encryption::set_iv(), Botan::CFB_Decryption::set_iv(), and Botan::XTS_Decryption::set_iv().

48 { encrypt_n(in, out, 1); }
Botan::BlockCipher::encrypt_n
virtual void encrypt_n(const byte in[], byte out[], size_t blocks) const =0

## ◆ encrypt() [2/2]

void Botan::BlockCipher::encrypt | ( | byte | block[] | ) | const
| inlineinherited

Encrypt a block.

Parameters

  block | the plaintext block to be encrypted Must be of length block_size(). Will hold the result when the function has finished.

Definition at line 66 of file block_cipher.h.

66 { encrypt_n(block, block, 1); }
Botan::BlockCipher::encrypt_n
virtual void encrypt_n(const byte in[], byte out[], size_t blocks) const =0

## ◆ encrypt_n()

void Botan::SEED::encrypt_n | ( | const byte | in[],
|  | byte | out[],
|  | size_t | blocks
| ) |  | const
| virtual

Encrypt one or more blocks

Parameters

  in | the input buffer (multiple of block_size())
  out | the output buffer (same size as in)
  blocks | the number of blocks to process

Implements Botan::BlockCipher.

Definition at line 25 of file seed.cpp.

References Botan::Block_Cipher_Fixed_Params< 16, 16 >::BLOCK_SIZE, Botan::load_be< u32bit >(), and Botan::store_be().

26 {
27 for(size_t i = 0; i != blocks; ++i)
28 {
29 u32bit B0 = load_be<u32bit>(in, 0);
30 u32bit B1 = load_be<u32bit>(in, 1);
31 u32bit B2 = load_be<u32bit>(in, 2);
32 u32bit B3 = load_be<u32bit>(in, 3);
33
34 G_FUNC G;
35
36 for(size_t j = 0; j != 16; j += 2)
37 {
38 u32bit T0, T1;
39
40 T0 = B2 ^ K[2*j];
41 T1 = G(B2 ^ B3 ^ K[2*j+1]);
42 T0 = G(T1 + T0);
43 T1 = G(T1 + T0);
44 B1 ^= T1;
45 B0 ^= T0 + T1;
46
47 T0 = B0 ^ K[2*j+2];
48 T1 = G(B0 ^ B1 ^ K[2*j+3]);
49 T0 = G(T1 + T0);
50 T1 = G(T1 + T0);
51 B3 ^= T1;
52 B2 ^= T0 + T1;
53 }
54
55 store_be(out, B2, B3, B0, B1);
56
57 in += BLOCK_SIZE;
58 out += BLOCK_SIZE;
59 }
60 }
Botan::Block_Cipher_Fixed_Params< 16, 16 >::BLOCK_SIZE
Definition: block_cipher.h:107
Botan::load_be< u32bit >
u32bit load_be< u32bit >(const byte in[], size_t off)
Definition: loadstor.h:166
Botan::store_be
void store_be(u16bit in, byte out[2])
Definition: loadstor.h:412
Botan::u32bit
unsigned int u32bit
Definition: types.h:32

## ◆ key_spec()

Key_Length_Specification Botan::Block_Cipher_Fixed_Params< BS, KMIN, 0 , 1 >::key_spec | ( |  | ) | const
| inlinevirtualinherited

Returns
  object describing limits on key size

Implements Botan::SymmetricAlgorithm.

Definition at line 110 of file block_cipher.h.

111 {
112 return Key_Length_Specification(KMIN, KMAX, KMOD);
113 }

## ◆ maximum_keylength()

size_t Botan::SymmetricAlgorithm::maximum_keylength | ( |  | ) | const
| inlineinherited

Returns
  minimum allowed key length

Definition at line 33 of file sym_algo.h.

Referenced by Botan::Cascade_Cipher::decrypt_n(), and Botan::ANSI_X931_RNG::randomize().

34 {
35 return key_spec().maximum_keylength();
36 }
Botan::Key_Length_Specification::maximum_keylength
size_t maximum_keylength() const
Definition: key_spec.h:69
Botan::SymmetricAlgorithm::key_spec
virtual Key_Length_Specification key_spec() const =0

## ◆ minimum_keylength()

size_t Botan::SymmetricAlgorithm::minimum_keylength | ( |  | ) | const
| inlineinherited

Returns
  maxmium allowed key length

Definition at line 41 of file sym_algo.h.

42 {
43 return key_spec().minimum_keylength();
44 }
Botan::SymmetricAlgorithm::key_spec
virtual Key_Length_Specification key_spec() const =0
Botan::Key_Length_Specification::minimum_keylength
size_t minimum_keylength() const
Definition: key_spec.h:61

## ◆ name()

std::string Botan::SEED::name | ( |  | ) | const
| inlinevirtual

Returns
  name of this algorithm

Implements Botan::Algorithm.

Definition at line 25 of file seed.h.

25 { return "SEED"; }

## ◆ parallel_bytes()

size_t Botan::BlockCipher::parallel_bytes | ( |  | ) | const
| inlineinherited

Returns
  prefererred parallelism of this cipher in bytes

Definition at line 35 of file block_cipher.h.

36 {
37 return parallelism() * block_size() * BOTAN_BLOCK_CIPHER_PAR_MULT;
38 }
Botan::BlockCipher::parallelism
virtual size_t parallelism() const
Definition: block_cipher.h:30
Botan::BlockCipher::block_size
virtual size_t block_size() const =0

## ◆ parallelism()

virtual size_t Botan::BlockCipher::parallelism | ( |  | ) | const
| inlinevirtualinherited

Returns
  native parallelism of this cipher in blocks

Reimplemented in Botan::AES_256_NI, Botan::AES_192_NI, Botan::AES_128_NI, Botan::IDEA_SSE2, Botan::Noekeon_SIMD, Botan::Serpent_SIMD, and Botan::XTEA_SIMD.

Definition at line 30 of file block_cipher.h.

30 { return 1; }

## ◆ set_key() [1/2]

void Botan::SymmetricAlgorithm::set_key | ( | const SymmetricKey & | key | ) |
| inlineinherited

Set the symmetric key of this object.

Parameters

  key | the SymmetricKey to be set.

Definition at line 60 of file sym_algo.h.

References Botan::OctetString::begin(), and Botan::OctetString::length().

Referenced by Botan::aont_unpackage(), Botan::CTR_BE::clear(), Botan::OFB::clear(), Botan::DESX::decrypt_n(), Botan::Cascade_Cipher::decrypt_n(), Botan::Lion::decrypt_n(), Botan::PKCS5_PBKDF2::derive_key(), Botan::ECB_Decryption::ECB_Decryption(), Botan::ECB_Encryption::ECB_Encryption(), Botan::Lion::encrypt_n(), Botan::HMAC_RNG::HMAC_RNG(), Botan::MAC_Filter::MAC_Filter(), Botan::ANSI_X931_RNG::randomize(), Botan::Randpool::randomize(), Botan::HMAC_RNG::reseed(), Botan::XTS_Encryption::set_key(), Botan::EAX_Base::set_key(), Botan::XTS_Decryption::set_key(), Botan::Record_Writer::set_keys(), Botan::Record_Reader::set_keys(), Botan::StreamCipher_Filter::StreamCipher_Filter(), Botan::DLIES_Decryptor::~DLIES_Decryptor(), and Botan::DLIES_Encryptor::~DLIES_Encryptor().

61 { set_key(key.begin(), key.length()); }
Botan::SymmetricAlgorithm::set_key
void set_key(const SymmetricKey &key)
Definition: sym_algo.h:60

## ◆ set_key() [2/2]

void Botan::SymmetricAlgorithm::set_key | ( | const byte | key[],
|  | size_t | length
| ) |  |
| inlineinherited

Set the symmetric key of this object.

Parameters

  key | the to be set as a byte array.
  length | in bytes of key param

Definition at line 68 of file sym_algo.h.

69 {
70 if(!valid_keylength(length))
71 throw Invalid_Key_Length(name(), length);
72 key_schedule(key, length);
73 }
Botan::SymmetricAlgorithm::valid_keylength
bool valid_keylength(size_t length) const
Definition: sym_algo.h:51
Botan::Algorithm::name
virtual std::string name() const =0

## ◆ valid_keylength()

bool Botan::SymmetricAlgorithm::valid_keylength | ( | size_t | length | ) | const
| inlineinherited

Check whether a given key length is valid for this algorithm.

Parameters

  length | the key length to be checked.

Returns
  true if the key length is valid.

Definition at line 51 of file sym_algo.h.

Referenced by Botan::aont_unpackage(), Botan::HMAC_RNG::HMAC_RNG(), Botan::Lion::Lion(), and Botan::Randpool::Randpool().

52 {
53 return key_spec().valid_keylength(length);
54 }
Botan::Key_Length_Specification::valid_keylength
bool valid_keylength(size_t length) const
Definition: key_spec.h:51
Botan::SymmetricAlgorithm::key_spec
virtual Key_Length_Specification key_spec() const =0

The documentation for this class was generated from the following files:

- src/block/seed/seed.h
- src/block/seed/seed.cpp